-- Original script bei Leiche, tweaked by DC (August 2011)

countdown=0				-- countdown after killing all straw dummies
endx=0; endy=0			-- position of last RC missile impact

function lightfx()
  x=getplayerx(0)
  y=getplayery(0)
  particle(p_muzzle,x,y)
  particlesize(0.8,2.0)
  particlerotation(0)
  particlealpha(1.0)
  particlefadealpha(0.04)
  particlecolor(255,100,0)
  for i=1,10 do
    particle(p_flare,x+math.random(-1000,1000)/100,y+math.random(-1000,1000)/100)
    size=math.random(200,500)/100
    particlesize(size,size)
    particlefadealpha(math.random(10,20)/1000)
    particlecolor(255,100,0)
    particlespeed(0,-math.random(20,150)/100)
  end
end

function mission_start()
  -- Start FX
  lightfx()
  playsound(sfx_turn_you)
  customstart()
  -- Overwrite RC function
  cc.rcmissile.missile.move=rc_overwrite
  -- Disable wind
  wind(0)
end
function customstart()
end

function mission_update()
  if (getframe()%5)==0 then
    strawdummycount=#objecttable(cc.strawdummy.id)
    -- All straw dummies destroyed?
    if strawdummycount==0 then
      countdown=countdown+1
      if countdown>25 then
        win()
      end
    end
  end
  -- All destroyed! Disable movement, scroll to impact!
  if countdown~=0 then
	cutscene()
	scroll(endx,endy)
  end
  customupdate()
end
function customupdate()
end

function mission_draw()
  customdraw()
end
function customdraw()
  if countdown==0 then
    hudmsgbox("Kill all straw dummies with your RC missiles! Your missiles do not destroy terrain!")
  else
    hudmsgbox("Horrido! That was awesome!")
  end
end

-- Overwrite RC Missile Projectile (no terrain destruction!)
function rc_overwrite(id,fx)
  -- Control by player
  if projectiles[id].timer==(14*50) then
    -- Start Control FX
    playsound(cc.rcmissile.sfx_homing)
    particle(p_ring,projectiles[id].x,projectiles[id].y)
    particlecolor(255,150,0)
  end
  if projectiles[id].timer<=(14*50) then
    rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
    if keydown(key_left)==1 then
      rot=rot-3
    elseif keydown(key_right)==1 then
      rot=rot+3
    end
    projectiles[id].sx=math.sin(math.rad(rot))*6.0
    projectiles[id].sy=-math.cos(math.rad(rot))*6.0
  else
    rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
  end
  -- Particle Tail
  if (fx==1) then
    particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
    particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
    particlefadealpha(0.01)
    if projectiles[id].timer<=(14*50) then
      particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
      particlefadealpha(0.04)
    end
  end
  -- Wind + Gravity influence on speed
  projectiles[id].sx=projectiles[id].sx+getwind()
  projectiles[id].sy=projectiles[id].sy+getgravity()
  -- Move (in substep loop for optimal collision precision)
  msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
  msubx=projectiles[id].sx/msubt
  msuby=projectiles[id].sy/msubt
  for i=1,msubt,1 do
    projectiles[id].x=projectiles[id].x+msubx
    projectiles[id].y=projectiles[id].y+msuby
    -- Collision
    if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 then
      if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
        projectiles[id].timer=0
        break
      end
    else
      projectiles[id].ignore=0
    end
    -- Water
    if (projectiles[id].y)>getwatery() then
      projectiles[id].timer=5
      -- Effects
      particle(p_waterhit,projectiles[id].x,projectiles[id].y)
      playsound(sfx_hitwater1)
      -- Free projectile
      freeprojectile(id)
      -- End Turn
      endturn()
      -- Regain Control (Missions)
      if inmission()==1 then
        playercontrol(1)
      end
      break
    end
  end
  -- Timer / Explode
  if (fx==1) and (projectiles[id].timer>1) then
    projectiles[id].timer=projectiles[id].timer-1
  end
  if projectiles[id].timer<=0 then
    -- Cause damage
    arealdamage(projectiles[id].x,projectiles[id].y,120,60)
    -- Destroy terrain !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! <--- CHANGED
    terrainexplosion(projectiles[id].x,projectiles[id].y,25,3)
	endx=projectiles[id].x
	endy=projectiles[id].y
    -- Crater
    grey=math.random(0,40)
    if math.random(0,1)==1 then
      terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
    else
      terrainalphaimage(gfx_crater150,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
    end
    -- Free projectile
    freeprojectile(id)
    -- End Turn
    endturn()
    -- Regain Control (Missions)
    if inmission()==1 then
      playercontrol(1)
    end
  end
  -- Scroll to projectile
  scroll(projectiles[id].x,projectiles[id].y)
end
