--------------------------------------------------------------------------------
-- Weapon Raft
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.raft={}

-- Load & Prepare Ressources
cc.raft.gfx_wpn=loadgfx("weapons/raft.bmp")							-- Weapon Image
setmidhandle(cc.raft.gfx_wpn)

--------------------------------------------------------------------------------
-- Weapon: raft
--------------------------------------------------------------------------------

cc.raft.id=addweapon("cc.raft","Raft",cc.raft.gfx_wpn,1)			-- Add Weapon (1 use)
addweaponinfo("Makes it possible to move over the water. Does not end the turn.")

function cc.raft.draw()												-- Draw
	if (weapon_mode==1) then
		setblend(blend_alpha)
		setalpha(1.0)
		setcolor(255,255,255)
		setscale(1,1)
		setrotation(0)
		drawimage(cc.raft.gfx_wpn,getplayerx(0),getwatery()-40)
	elseif (weapon_mode==2) then
		hudinfo("Not enough space to use the raft here!",1,255,0,0)
	end
end

function cc.raft.attack(attack)										-- Attack
	-- Use automatically (if possible)
	if (weapon_mode~=1) then
		if getplayery(0)<getwatery()-60 or collision(colplayer,getplayerx(0),getwatery()-60, 1,1,1,0)==0 then
			useweapon(1)
			weapon_mode=1
		else
			weapon_mode=2
		end
	-- Keep player away from water
	else
		if getplayery(0)>=getwatery()-55 then
			playerposition(0,getplayerx(0),getwatery()-55)
			if getplayeryspeed(0)>=0 then
				playerpush(0,0,0,1,0)
			end
			if keydown(key_jump)==1 then
				playerposition(0,getplayerx(0),getwatery()-60)
				playerpush(0,getplayerdirection(0)*3,-4,1,0)
			elseif keydown(key_backjump)==1 then
				playerposition(0,getplayerx(0),getwatery()-60)
				playerpush(0,getplayerdirection(0)*-1,-5,1,0)
			end
		end
		--Timeout (disable raft)
		if getframesleft()<=1 then
			weapon_mode=3
		end
	end
end