--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.strawdummy={}

-- Load & Prepare Ressources
cc.strawdummy.gfx=loadgfx("stuff/strawdummy.bmp")						-- Straw dummy graphic
cc.strawdummy.arrow=1													-- Draw Arrow (setting 1/0)
sethandle(cc.strawdummy.gfx,10,30)

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.strawdummy.id=addobject("cc.strawdummy",cc.strawdummy.gfx)			-- Add Object
function cc.strawdummy.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=5
	objects[id].sy=0
end
function cc.strawdummy.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(math.sin(id*10+os.clock()*2.0)*10.0)
	-- Draw
	drawimage(cc.strawdummy.gfx,x,y)
	-- Arrow
	if cc.strawdummy.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.strawdummy.update(id,x,y)
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.strawdummy.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.strawdummy.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		if objects[id].health<=0 then
			local x=getobjectx(id)
			local y=getobjecty(id)
			-- Explosion
			terrainexplosion(x,y,10,1)
			-- Remove
			removeobject(id)
			-- Particles
			for i=1,30 do
				particle(p_feather, x+math.random(-15,15), y+math.random(-35,5))
				particlecolor(255,math.random(180,255),0)
			end
		end
	end
end