--------------------------------------------------------------------------------
-- Zombie
-- Original Carnage Contest Object (for Zombie mission)
-- Script by DC, September 2012, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.zombie={}

-- Load & Prepare Ressources
cc.zombie.gfx0=loadgfx("stuff/zombie0.bmp")							-- Zombie graphic
setmidhandle(cc.zombie.gfx0)
cc.zombie.gfx1=loadgfx("stuff/zombie1.bmp")
setmidhandle(cc.zombie.gfx1)
cc.zombie.arrow=1													-- Draw Arrow (setting 1/0)
cc.zombie.score=0													-- Kill Score (missions)

--------------------------------------------------------------------------------
-- Object: Zombie
--------------------------------------------------------------------------------

cc.zombie.id=addobject("cc.zombie",cc.zombie.gfx0)			-- Add Object
function cc.zombie.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=50
	objects[id].sy=0
	objects[id].timer=0
	objects[id].frame=0
	objects[id].dir=parameter
end
function cc.zombie.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(objects[id].dir,1)
	setrotation(0)
	-- Draw
	if objects[id].frame==0 then
		drawimage(cc.zombie.gfx0,x,y-2)
	else
		drawimage(cc.zombie.gfx1,x,y-2)
	end
	-- Arrow
	if cc.zombie.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.zombie.update(id,x,y)
	-- Animation
	objects[id].timer=objects[id].timer+1
	if objects[id].timer>19 then
		objects[id].timer=0
		objects[id].frame=1-objects[id].frame
		if objects[id].frame==1 then
			-- Punch Players
			if collision(col20x20,x+objects[id].dir*11,y-5,0,1,0)==1 then
				if playercollision()~=0 then
					playerpush(playercollision(),objects[id].dir*3,-10)
					playerdamage(playercollision(),10)
					playsound(sfx_splatter1)
					particle(p_ring,getplayerx(playercollision()),getplayery(playercollision()))
					particlecolor(255,0,0)
					blood(getplayerx(playercollision()),getplayery(playercollision()))
				end
			end
		end
	end
	-- Move Left/Right
	x=x+objects[id].dir*0.5
	if collision(colplayer,x,y,1,1,1,-1,id)==1 then
		if terraincollision()==1 or objectcollision()>0 then
			-- Upwards/Downwards space?
			doturn=1
			for i=1,16,1 do
				if (i%2)==1 then offset=(i+1)/2 else offset=-(i/2) end
				if collision(colplayer,x,y+offset,1,1,1,-1,id)==0 then
					doturn=0; y=y+offset; break
				end
			end
			if doturn==1 then
				-- Move Back / Turn
				x=x-objects[id].dir*0.5
				if terraincollision()==1 or objectcollision()>0 then objects[id].dir=objects[id].dir*(-1) end
			end
		end
	end
	-- Fall Down
	objects[id].sy=objects[id].sy+getgravity()
	msubt=math.ceil(math.abs(objects[id].sy)/3)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(colplayer,x,y,1,1,1,-1,id)==1 then
			if terraincollision()==1 or objectcollision()>0 then
				objects[id].sy=0
				y=y-msuby
				break
			end
		end
		-- Water
		if (y)>getwatery()+300 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater3)
			-- Remove
			removeobject(id)
			return
		end
	end
	-- set new position
	objectposition(id,x,y)
end

function cc.zombie.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		local x=getobjectx(id)
		local y=getobjecty(id)
		blood(x,y)
		if objects[id].health<=0 then
			-- Remove
			removeobject(id)
			-- Score
			if cc.zombie.score>0 then
				setscore(getscore()+cc.zombie.score)
			end
		end
	end
end