--------------------------------------------------------------------------------
-- Weapon Bar
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.bar={}
cc.bar.gfx_wpn={}

-- Load & Prepare Ressources
for i=0,3,1 do
	cc.bar.gfx_wpn[i]=loadgfx("buildings/bar"..i..".bmp")					-- Weapon Image
	setmidhandle(cc.bar.gfx_wpn[i])
end
cc.bar.sfx_build=loadsfx("buildmetal.ogg")									-- Build Sound

--------------------------------------------------------------------------------
-- Weapon: Bar
--------------------------------------------------------------------------------

cc.bar.id=addweapon("cc.bar","Bar",cc.bar.gfx_wpn[0],3)						-- Add Weapon (3 uses)
addweaponinfo("Can be rotated. Becomes part of the terrain and can be destroyed. Does not end the turn.")

function cc.bar.draw()														-- Draw
	if getweaponcount('cc.bar',getplayerteam(0))>0 then
		-- HUD Positioning
		hudpositioning(pos_build,cc.bar.gfx_wpn[weapon_mode])
		-- HUD Info
		hudinfo("Press [Space] to rotate the bar!")
	end
end

function cc.bar.attack(attack)												-- Attack
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if (weapon_shots<=0) and (attack==1) and (weapon_timer==0) then
		-- Rotate
		weapon_timer=15
		weapon_mode=weapon_mode+1
		if weapon_mode>3 then
			weapon_mode=0
		end
	end
	if getweaponcount('cc.bar',getplayerteam(0))>0 and weapon_position==1 then 
		-- Use weapon and allow to use another one (and the same one) afterwards (2)
		useweapon(2)
		weapon_position=0
		-- Draw
		terrainimage(cc.bar.gfx_wpn[weapon_mode],weapon_x,weapon_y)
		-- Sound
		playsound(cc.bar.sfx_build)
		-- Particles
		particle(p_muzzle,weapon_x,weapon_y)
		particlesize(0.9,2.5)
		particlefadealpha(0.02)
		if weapon_mode==0 then particlerotation(45) end
		if weapon_mode==1 then particlerotation(90) end
		if weapon_mode==2 then particlerotation(-45) end
		if weapon_mode==3 then particlerotation(180) end
	end
end