--------------------------------------------------------------------------------
-- Weapon Block
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.block={}

-- Load & Prepare Ressources
cc.block.gfx_wpn=loadgfx("buildings/block.bmp")							-- Weapon Image
setmidhandle(cc.block.gfx_wpn)
cc.block.sfx_build=loadsfx("buildstone.ogg")							-- Build Sound

--------------------------------------------------------------------------------
-- Weapon: Block
--------------------------------------------------------------------------------

cc.block.id=addweapon("cc.block","Block",cc.block.gfx_wpn,3)			-- Add Weapon (3 uses)
addweaponinfo("Becomes part of the terrain and can be destroyed. Does not end the turn.")

function cc.block.draw()												-- Draw
	-- HUD Positioning
	if getweaponcount('cc.block',getplayerteam(0))>0 then
		hudpositioning(pos_build,cc.block.gfx_wpn)
	end
end

function cc.block.attack(attack)										-- Attack
	if getweaponcount('cc.block',getplayerteam(0))>0 and weapon_position==1 then 
		-- Use weapon and allow to use another one (and the same one) afterwards (2)
		useweapon(2)
		weapon_position=0
		-- Draw
		terrainimage(cc.block.gfx_wpn,weapon_x,weapon_y)
		-- Sound
		playsound(cc.block.sfx_build)
		-- Particles
		for angle=0,350,35 do
			particle(p_smoke,weapon_x+math.sin(math.rad(angle))*8,weapon_y-math.cos(math.rad(angle))*8)
			particlespeed(math.sin(math.rad(angle))*0.5,-math.cos(math.rad(angle))*0.5)
			particlecolor(150,150,150)
		end
	end
end