--------------------------------------------------------------------------------
-- Weapon Bridge Part
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.bridgepart={}

-- Load & Prepare Ressources
cc.bridgepart.gfx_wpn=loadgfx("buildings/bridgepart.bmp")							-- Weapon Image
setmidhandle(cc.bridgepart.gfx_wpn)
cc.bridgepart.sfx_build=loadsfx("buildwood.ogg")									-- Build Sound

--------------------------------------------------------------------------------
-- Weapon: Bridge Part
--------------------------------------------------------------------------------

cc.bridgepart.id=addweapon("cc.bridgepart","Bridge Part",cc.bridgepart.gfx_wpn,5)	-- Add Weapon (5 uses)
addweaponinfo("Becomes part of the terrain and can be destroyed. Does not end the turn.")

function cc.bridgepart.draw()														-- Draw
	-- HUD Positioning
	if getweaponcount('cc.bridgepart',getplayerteam(0))>0 then
		hudpositioning(pos_build,cc.bridgepart.gfx_wpn)
	end
end

function cc.bridgepart.attack(attack)												-- Attack
	if getweaponcount('cc.bridgepart',getplayerteam(0))>0 and weapon_position==1 then 
		-- Use weapon and allow to use another one (and the same one) afterwards (2)
		useweapon(2)
		weapon_position=0
		-- Draw
		terrainimage(cc.bridgepart.gfx_wpn,weapon_x,weapon_y)
		-- Sound
		playsound(cc.bridgepart.sfx_build)
		-- Particles
		for angle=0,350,70 do
			particle(p_smoke,weapon_x+math.sin(math.rad(angle))*1,weapon_y-math.cos(math.rad(angle))*1)
			particlespeed(math.sin(math.rad(angle))*0.5,-math.cos(math.rad(angle))*0.5)
			particlecolor(150,100,100)
		end
	end
end