--------------------------------------------------------------------------------
-- Weapon Small Block
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.smallblock={}

-- Load & Prepare Ressources
cc.smallblock.gfx_wpn=loadgfx("buildings/smallblock.bmp")							-- Weapon Image
setmidhandle(cc.smallblock.gfx_wpn)
cc.smallblock.sfx_build=loadsfx("buildstone.ogg")									-- Build Sound

--------------------------------------------------------------------------------
-- Weapon: Small Block
--------------------------------------------------------------------------------

cc.smallblock.id=addweapon("cc.smallblock","Small Block",cc.smallblock.gfx_wpn,5)	-- Add Weapon (5 uses)
addweaponinfo("Becomes part of the terrain and can be destroyed. Does not end the turn.")

function cc.smallblock.draw()														-- Draw
	-- HUD Positioning
	if getweaponcount('cc.smallblock',getplayerteam(0))>0 then
		hudpositioning(pos_build,cc.smallblock.gfx_wpn)
	end
end

function cc.smallblock.attack(attack)												-- Attack
	if getweaponcount('cc.smallblock',getplayerteam(0))>0 and weapon_position==1 then 
		-- Use weapon and allow to use another one (and the same one) afterwards (2)
		useweapon(2)
		weapon_position=0
		-- Draw
		terrainimage(cc.smallblock.gfx_wpn,weapon_x,weapon_y)
		-- Sound
		playsound(cc.smallblock.sfx_build)
		-- Particles
		for angle=0,350,70 do
			particle(p_smoke,weapon_x+math.sin(math.rad(angle))*2,weapon_y-math.cos(math.rad(angle))*2)
			particlespeed(math.sin(math.rad(angle))*0.5,-math.cos(math.rad(angle))*0.5)
			particlecolor(150,150,150)
		end
	end
end