--------------------------------------------------------------------------------
-- Carnage Contest Game Mode Script
-- Script by DC, May 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

addgamemode("fortress","Fortress",0,0,"positioning=0")

-- Load & Prepare Ressources
fortress_gm_buildstone=loadsfx("buildstone.ogg")			-- Build Stone Sound
fortress_gm_buildwood=loadsfx("buildwood.ogg")				-- Build Wood Sound
fortress_gm_buildings={}
fortress_gm_prices={}
fortress_gm_money={300,300,300,300,300,300,300,300}
fortress_gm_built={0,0,0,0,0,0,0,0}
fortress_gm_buildingid=0

fortress_gm_buildings[0]=loadgfx("buildings/bridgepart.bmp")
setmidhandle(fortress_gm_buildings[0])
fortress_gm_prices[0]=5
fortress_gm_buildings[1]=loadgfx("buildings/smallblock.bmp")
setmidhandle(fortress_gm_buildings[1])
fortress_gm_prices[1]=10
fortress_gm_buildings[2]=loadgfx("buildings/block.bmp")
setmidhandle(fortress_gm_buildings[2])
fortress_gm_prices[2]=25


function fortress_gm_start()
	fortress_gm_buildingid=2
	fortress_gm_money={300,300,300,300,300,300,300,300}
	fortress_gm_built={0,0,0,0,0,0,0,0}
	--terrainrect(0,0,getmapwidth(),getmapheight(),0x00000000)
	--resizeterrain(2000,700)
end

function fortress_gm_draw()
	if getframe()>1 then
		if fortress_gm_money[getplayerteam(0)+1]>0 and fortress_gm_built[getplayerteam(0)+1]==0 then
			--Draw interface
			if fortress_gm_prices[fortress_gm_buildingid]<=fortress_gm_money[getplayerteam(0)+1] then
				hudpositioning(pos_build,fortress_gm_buildings[fortress_gm_buildingid],300,0,1,1)
				hudinfo(fortress_gm_prices[fortress_gm_buildingid]..'$ ('..fortress_gm_money[getplayerteam(0)+1]..'$ left)',0,0,255,0)
			else
				hudinfo(fortress_gm_prices[fortress_gm_buildingid]..'$ ('..fortress_gm_money[getplayerteam(0)+1]..'$ left)',0,255,0,0)
			end
			setalpha(1.0)
			setrotation(os.clock()*100)
			setscale(1,1)
			setcolor(255,255,0)
			setblend(blend_light)
			drawhud(gfx_flare2, screenwidth()/2, screenheight()/2-180, 1)
			setrotation(0)
			setblend(blend_mask)
			setcolor(255,255,255)
			drawhud(fortress_gm_buildings[fortress_gm_buildingid], screenwidth()/2, screenheight()/2-180, 1)
		end
	end
end

function fortress_gm_update()
	if getframe()==1 then
		-- Start turn
		fortress_gm_buildingid=2
		-- Build or play mode?
		if fortress_gm_built[getplayerteam(0)+1]==1 then
			-- Play mode
			playercontrol(1)
			playerweaponswitch(1)
		else
			-- Build mode
			playercontrol(0)
			playerweaponswitch(0)
		end
		-- Setup positions
		if getturn()==1 then
			-- Count teams
			players=playertable()
			teams={0,0,0,0,0,0,0,0}
			teamcount=0
			for i=1,#players,1 do
				if teams[getplayerteam(players[i])+1]==0 then
					teams[getplayerteam(players[i])+1]=1
					teamcount=teamcount+1
				end
			end
			-- Position players
			spaces=teamcount+1
			space=(getmapwidth()-(teamcount*100))/spaces
			offset=space
			for i=0,7,1 do
				if teams[i+1]==1 then
					terraincircle(offset+50,math.ceil(getmapheight()/2),100,0x00000000)
					terrainrect(offset,math.ceil(getmapheight()/2)+15,100,2,0xFF906226)
					terrainrect(offset,math.ceil(getmapheight()/2)+17,100,2,0xFF734C1A)
					playercount=0
					for j=1,#players,1 do
						if getplayerteam(players[j])==i then
							playercount=playercount+1
						end
					end
					suboffset=50+7.5-(playercount*7.5)
					for j=1,#players,1 do
						if getplayerteam(players[j])==i then
							playerposition(players[j],offset+suboffset,getmapheight()/2)
							suboffset=suboffset+15
						end
					end
					offset=offset+100+space
				end
			end
		end
	elseif getplayercontrol(0)==0 then
		-- Switch Building
		if keyhit(key_left)==1 then
			fortress_gm_buildingid=fortress_gm_buildingid-1
			if fortress_gm_buildingid<0 then fortress_gm_buildingid=2 end
		elseif keyhit(key_right)==1 then
			fortress_gm_buildingid=fortress_gm_buildingid+1
			if fortress_gm_buildingid>2 then fortress_gm_buildingid=0 end
		end
		-- Place Building
		if weapon_position==1 and fortress_gm_prices[fortress_gm_buildingid]<=fortress_gm_money[getplayerteam(0)+1] then
			weapon_position=0
			fortress_gm_money[getplayerteam(0)+1]=fortress_gm_money[getplayerteam(0)+1]-fortress_gm_prices[fortress_gm_buildingid]
			-- Draw
			terrainimage(fortress_gm_buildings[fortress_gm_buildingid],weapon_x,weapon_y)
			-- Effects
			if fortress_gm_buildingid==0 then
				-- Sound
				playsound(fortress_gm_buildwood)
				-- Particles
				for angle=0,350,70 do
					particle(p_smoke,weapon_x+math.sin(math.rad(angle))*1,weapon_y-math.cos(math.rad(angle))*1)
					particlespeed(math.sin(math.rad(angle))*0.5,-math.cos(math.rad(angle))*0.5)
					particlecolor(150,100,100)
				end
			elseif fortress_gm_buildingid==1 then
				-- Sound
				playsound(fortress_gm_buildstone)
				-- Particles
				for angle=0,350,70 do
					particle(p_smoke,weapon_x+math.sin(math.rad(angle))*2,weapon_y-math.cos(math.rad(angle))*2)
					particlespeed(math.sin(math.rad(angle))*0.5,-math.cos(math.rad(angle))*0.5)
					particlecolor(150,150,150)
				end
			elseif fortress_gm_buildingid==2 then
				-- Sound
				playsound(fortress_gm_buildstone)
				-- Particles
				for angle=0,350,35 do
					particle(p_smoke,weapon_x+math.sin(math.rad(angle))*8,weapon_y-math.cos(math.rad(angle))*8)
					particlespeed(math.sin(math.rad(angle))*0.5,-math.cos(math.rad(angle))*0.5)
					particlecolor(150,150,150)
				end
			end
			-- End turn
			if fortress_gm_money[getplayerteam(0)+1]<=0 then
				endturn()
			end
		end
	end
end

function fortress_gm_playerdamage()
	-- Do nothing
end

function fortress_gm_endturn()
	-- Player has built!
	fortress_gm_built[getplayerteam(0)+1]=1
end